{% extends 'frontend/layout.html.twig' %}
{% block body %}
    <div class="notesHeader">
        <h5 class="text-white">Pruebas con symfony 3.4 y mongodb </h5>
    </div>
    <div class="notesBoby">
        <div class="notesBoby">
            <div class="row">
                <div class="col-sm-4">
                    <form class="text-center border border-light p-2" name="nota">
                        <div class="form-group">
                            <input type="text"class="form-control" name="notaContent" id="notaContent" aria-describedby="emailHelp" placeholder="Ingresa un mensaje" />
                        </div>
                        <div class="form-group">
                            <input type="text" class="form-control" name="notaUser" id="notaUser" aria-describedby="emailHelp" placeholder="Ingresa tu nombre" />
                        </div>
                        <button type="submit"  onClick="mongoApi.agregarNota(event)" class="btn btn-primary">Guardar</button>
                    </form>
                </div>
                <div class="col-sm-8">
                    <div id='listadodenotas'>
                        <div class="lds-ripple centered"><div></div><div></div></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script>

        var service = new WebSocket("ws://192.168.85.194:83");

        window.onload = function () {
            service.onmessage = function (event) {
                mongoApi.obtenerLista();
            }
            service.onopen = function () {
                service.send("hello!");
            }
            service.onclose = function () {
                console.log("closed");
            }
            service.onerror = function () {
                console.log("error");
            }
        }

        function emitirMensaje(){
            service.send("loky");
        }

        var mongoApi = {
            url: 'http://192.168.85.193:90/apis/notas',
            xhr: new XMLHttpRequest(),
            ultimoHash: "",

            obtenerLista: function () {
                var _this = this;

                $.get(this.url + '/?nocache=' + (new Date).getTime(), function(data, status){
                    var notas = [];
                    data.list.forEach(nota => {
                        var {notaContent, notaUser, _id} = nota;
                        notas.unshift({
                            key: _id.$oid,
                            notaId: _id.$oid,
                            notaContent: notaContent,
                            notaUser: notaUser
                        })
                    });
                    notas.reverse();
                    _this.generarListado(notas, data.hash);
                });


                _this.xhr.open('GET', (this.url + '/?nocache=' + (new Date).getTime()), true);
                _this.xhr.setRequestHeader('Cache-Control', 'no-cache');
                _this.xhr.onload = function () {
                    var data = JSON.parse(this.response);
                    if (_this.xhr.status >= 200 && _this.xhr.status < 400) {

                    } else {
                        console.log('No data api');
                    }
                }
                _this.xhr.send();
            },
            generarListado: function (notas, hash) {
                var hashActual = hash;
                if(this.ultimoHash != hashActual){
                    var allOrdersHtml = "";
                    notas.map((nota, key) => {
                        var individialOrderHtml = `<div class="card text-center mt-4">
                     <div class="card-header">
                     usuario: ` + nota.notaUser + `
                     </div>
                     <div class="card-body">
                     <h5 class="card-title">` + nota.notaContent + `</h5>
                     <button type="button" onclick="mongoApi.eliminarNota('${nota.key}')" class="btn btn-primary">Eliminar</button>
                     </div>
                     </div>
                     `;
                        allOrdersHtml += individialOrderHtml;
                    });
                    $('#listadodenotas').html(allOrdersHtml);
                }
                this.ultimoHash = hashActual;
            },
            agregarNota: function (event) {
                event.preventDefault();
                if($('#notaContent').val() && $('#notaUser').val()){
                    $('#notaUser').prop("disabled", true);
                    var formData = new FormData();
                    formData.append("notaContent", $('#notaContent').val());
                    formData.append("notaUser", $('#notaUser').val());
                    $('#notaContent').val("");
                    $('#notaContent').focus();
                    var _this = this;
                    _this.xhr.open("POST", (this.url + '/putData'), true);
                    _this.xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
                    _this.xhr.onload = function () {
                        var data = JSON.parse(this.response);
                        if (_this.xhr.status >= 200 && _this.xhr.status < 400) {
                            //_this.obtenerLista();
                            emitirMensaje();
                        } else {
                            console.log('No data api');
                        }
                    };
                    _this.xhr.send(formData);
                }
            },
            eliminarNota: function(notaId){
                var _this = this;
                _this.xhr.open("DELETE", (this.url + '/deleteData'), true);
                _this.xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                _this.xhr.onload = function () {
                    var data = JSON.parse(this.response);
                        if (_this.xhr.status >= 200 && _this.xhr.status < 400) {
                        //_this.obtenerLista();
                        emitirMensaje();
                    } else {
                        console.log('No data api');
                    }
                };
                _this.xhr.send("notaId=" + notaId);
            }
        }
        mongoApi.obtenerLista();
    </script>
{% endblock %}
